All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section ["parameter=[value]" ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 respository. It supports any combination of subversion, git, cvs, mecurial,
34 bzr and darcs repositories, and support for other revision control systems can
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
111 To see the built-in library of shell functions contained in mr:
113 mr config DEFAULT lib
115 The ~/.mrconfig file is used by default. To use a different config file,
124 Actions can be abbreviated to any unambiguous subsctring, so
125 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
157 Just operate on the repository for the current directory, do not
158 recurse into deeper repositories.
162 Run the specified number of jobs in parallel. This can greatly speed up
163 operations such as updates. It is not recommended for interactive
170 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
171 file in your home directory, and this can in turn chain load .mrconfig files
174 Here is an example .mrconfig file:
177 checkout = svn co svn://svn.example.com/src/trunk src
181 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
183 git checkout -b mybranch origin/master
185 The .mrconfig file uses a variant of the INI file format. Lines starting with
186 "#" are comments. Values can be continued to the following line by
187 indenting the line with whitespace.
189 The "DEFAULT" section allows setting default values for the sections that
192 The "ALIAS" section allows adding aliases for actions. Each parameter
193 is an alias, and its value is the action to use.
195 All other sections add repositories. The section header specifies the
196 directory where the repository is located. This is relative to the directory
197 that contains the mrconfig file, but you can also choose to use absolute
200 Within a section, each parameter defines a shell command to run to handle a
201 given action. mr contains default handlers for "update", "status",
202 "commit", and other standard actions. Normally you only need to specify what
203 to do for "checkout".
205 Note that these shell commands are run in a "set -e" shell
206 environment, where any additional parameters you pass are available in
207 "$@". The "checkout" command is run in the parent of the repository
208 directory, since the repository isn't checked out yet. All other commands
209 are run inside the repository, though not necessarily at the top of it.
211 The "MR_REPO" environment variable is set to the path to the top of the
212 repository. (For the "register" action, "MR_REPO" is instead set to the
213 basename of the directory that should be created when checking the
216 The "MR_CONFIG" environment variable is set to the .mrconfig file
217 that defines the repo being acted on, or, if the repo is not yet in a config
218 file, the .mrconfig file that should be modified to register the repo.
220 A few parameters have special meanings:
226 If the "skip" parameter is set and its command returns true, then B<mr>
227 will skip acting on that repository. The command is passed the action
230 Here are two examples. The first skips the repo unless
231 mr is run by joey. The second uses the hours_since function
232 (included in mr's built-in library) to skip updating the repo unless it's
233 been at least 12 hours since the last update.
235 skip = test $(whoami) != joey
236 skip = [ "$1" = update ] && ! hours_since "$1" 12
240 The "order" parameter can be used to override the default ordering of
241 repositories. The default order value is 10. Use smaller values to make
242 repositories be processed earlier, and larger values to make repositories
245 Note that if a repository is located in a subdirectory of another
246 repository, ordering it to be processed earlier is not recommended.
250 If the "chain" parameter is set and its command returns true, then B<mr>
251 will try to load a .mrconfig file from the root of the repository. (You
252 should avoid chaining from repositories with untrusted committers.)
256 If the "include" parameter is set, its command is ran, and should output
257 additional mrconfig file content. The content is included as if it were
258 part of the including file.
260 Unlike all other parameters, this parameter does not need to be placed
265 The "lib" parameter can specify some shell code that will be run before each
266 command, this can be a useful way to define shell functions for other commands
271 When looking for a command to run for a given action, mr first looks for
272 a parameter with the same name as the action. If that is not found, it
273 looks for a parameter named "rcs_action" (substituting in the name of the
274 revision control system and the action). The name of the revision control
275 system is itself determined by running each defined "rcs_test" action,
278 Internally, mr has settings for "git_update", "svn_update", etc. To change
279 the action that is performed for a given revision control system, you can
280 override these rcs specific actions. To add a new revision control system,
281 you can just add rcs specific actions for it.
285 Copyright 2007 Joey Hess <joey@kitenet.net>
287 Licensed under the GNU GPL version 2 or higher.
289 http://kitenet.net/~joey/code/mr/
298 use Cwd qw(getcwd abs_path);
300 # things that can happen when mr runs a command
309 my $config_overridden=0;
315 my $directory=getcwd();
322 my (@ok, @failed, @skipped);
327 my ($action, $dir, $topdir, $subdir) = @_;
330 foreach my $rcs_test (
332 length $a <=> length $b
335 } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
336 my ($rcs)=$rcs_test=~/(.*)_test/;
337 $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
338 $test.="if my_$rcs_test; then echo $rcs; fi\n";
340 $test=$config{$topdir}{$subdir}{lib}."\n".$test
341 if exists $config{$topdir}{$subdir}{lib};
343 print "mr $action: running rcs test >>$test<<\n" if $verbose;
348 print STDERR "mr $action: found multiple possible repository types ($rcs) for $topdir$subdir\n";
359 sub findcommand { #{{{
360 my ($action, $dir, $topdir, $subdir, $is_checkout) = @_;
362 if (exists $config{$topdir}{$subdir}{$action}) {
363 return $config{$topdir}{$subdir}{$action};
370 my $rcs=rcs_test(@_);
373 exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
374 return $config{$topdir}{$subdir}{$rcs."_".$action};
382 my ($action, $dir, $topdir, $subdir) = @_;
384 $ENV{MR_CONFIG}=$configfiles{$topdir};
385 my $lib=exists $config{$topdir}{$subdir}{lib} ?
386 $config{$topdir}{$subdir}{lib}."\n" : "";
387 my $is_checkout=($action eq 'checkout');
391 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
395 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
397 elsif ($action =~ /update/) {
399 return action("checkout", $dir, $topdir, $subdir);
405 my $skiptest=findcommand("skip", $dir, $topdir, $subdir, $is_checkout);
406 my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
408 if (defined $skiptest) {
409 my $test="set -e;".$lib.
410 "my_action(){ $skiptest\n }; my_action '$action'";
411 print "mr $action: running skip test >>$test<<\n" if $verbose;
412 my $ret=system($test);
414 if (($? & 127) == 2) {
415 print STDERR "mr $action: interrupted\n";
419 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
423 if ($ret >> 8 == 0) {
424 print "mr $action: $dir skipped per config file\n" if $verbose;
429 if ($is_checkout && ! -d $dir) {
430 print "mr $action: creating parent directory $dir\n" if $verbose;
431 system("mkdir", "-p", $dir);
434 if (! $no_chdir && ! chdir($dir)) {
435 print STDERR "mr $action: failed to chdir to $dir: $!\n";
438 elsif (! defined $command) {
439 my $rcs=rcs_test(@_);
440 if (! defined $rcs) {
441 print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
445 print STDERR "mr $action: no defined $action command for $rcs repository $topdir$subdir, skipping\n";
451 print "mr $action: $topdir$subdir\n";
455 $s=~s/^\Q$topdir$subdir\E\/?//;
456 print "mr $action: $topdir$subdir (in subdir $s)\n";
458 $command="set -e; ".$lib.
459 "my_action(){ $command\n }; my_action ".
460 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
461 print "mr $action: running >>$command<<\n" if $verbose;
462 my $ret=system($command);
464 if (($? & 127) == 2) {
465 print STDERR "mr $action: interrupted\n";
469 print STDERR "mr $action: received signal ".($? & 127)."\n";
472 print STDERR "mr $action: failed ($ret)\n" if $verbose;
473 if ($ret >> 8 != 0) {
474 print STDERR "mr $action: command failed\n";
477 print STDERR "mr $action: command died ($ret)\n";
482 if ($action eq 'checkout' && ! -d $dir) {
483 print STDERR "mr $action: $dir missing after checkout\n";;
492 # run actions on multiple repos, in parallel
502 while (@fhs or @repos) {
503 while ($running < $jobs && @repos) {
505 my $repo = shift @repos;
506 pipe(my $outfh, CHILD_STDOUT);
507 pipe(my $errfh, CHILD_STDERR);
509 unless ($pid = fork) {
510 die "mr $action: cannot fork: $!" unless defined $pid;
511 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
512 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
517 exit action($action, @$repo);
521 push @active, [$pid, $repo];
522 push @fhs, [$outfh, $errfh];
525 my ($rin, $rout) = ('','');
527 foreach my $fh (@fhs) {
528 next unless defined $fh;
529 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
530 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
532 $nfound = select($rout=$rin, undef, undef, 1);
533 foreach my $channel (0, 1) {
534 foreach my $i (0..$#fhs) {
535 next unless defined $fhs[$i];
536 my $fh = $fhs[$i][$channel];
537 next unless defined $fh;
538 if (vec($rout, fileno($fh), 1) == 1) {
540 if (sysread($fh, $r, 1024) == 0) {
542 $fhs[$i][$channel] = undef;
543 if (! defined $fhs[$i][0] &&
544 ! defined $fhs[$i][1]) {
545 waitpid($active[$i][0], 0);
546 print STDOUT $out[$i][0];
547 print STDERR $out[$i][1];
548 record($active[$i][1], $? >> 8);
550 splice(@active, $i, 1);
555 $out[$i][$channel] .= $r;
563 my $dir=shift()->[0];
570 elsif ($ret == FAILED) {
574 elsif ($ret == SKIPPED) {
577 elsif ($ret == ABORT) {
581 die "unknown exit status $ret";
587 if (! @ok && ! @failed && ! @skipped) {
588 die "mr $action: no repositories found to work on\n";
590 print "mr $action: finished (".join("; ",
591 showstat($#ok+1, "ok", "ok"),
592 showstat($#failed+1, "failed", "failed"),
593 showstat($#skipped+1, "skipped", "skipped"),
597 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
600 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
610 return "$count ".($count > 1 ? $plural : $singular);
615 # an ordered list of repos
618 foreach my $topdir (sort keys %config) {
619 foreach my $subdir (sort keys %{$config{$topdir}}) {
623 order => $config{$topdir}{$subdir}{order},
628 $a->{order} <=> $b->{order}
630 $a->{topdir} cmp $b->{topdir}
632 $a->{subdir} cmp $b->{subdir}
636 # figure out which repos to act on
637 sub selectrepos { #{{{
639 foreach my $repo (repolist()) {
640 my $topdir=$repo->{topdir};
641 my $subdir=$repo->{subdir};
643 next if $subdir eq 'DEFAULT';
644 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
646 $dir.="/" unless $dir=~/\/$/;
647 $d.="/" unless $d=~/\/$/;
648 next if $no_recurse && $d ne $dir;
649 next if $dir ne $d && $dir !~ /^\Q$d\E/;
650 push @repos, [$dir, $topdir, $subdir];
653 # fallback to find a leaf repo
654 foreach my $repo (reverse repolist()) {
655 my $topdir=$repo->{topdir};
656 my $subdir=$repo->{subdir};
658 next if $subdir eq 'DEFAULT';
659 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
661 $dir.="/" unless $dir=~/\/$/;
662 $d.="/" unless $d=~/\/$/;
663 if ($d=~/^\Q$dir\E/) {
664 push @repos, [$dir, $topdir, $subdir];
674 sub loadconfig { #{{{
681 if (ref $f eq 'GLOB') {
690 my $absf=abs_path($f);
691 if ($loaded{$absf}) {
696 ($dir)=$f=~/^(.*\/)[^\/]+$/;
697 if (! defined $dir) {
700 $dir=abs_path($dir)."/";
702 if (! exists $configfiles{$dir}) {
703 $configfiles{$dir}=$f;
706 # copy in defaults from first parent
708 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
709 if ($parent eq '/') {
712 if (exists $config{$parent} &&
713 exists $config{$parent}{DEFAULT}) {
714 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
719 print "mr: loading config $f\n" if $verbose;
720 open($in, "<", $f) || die "mr: open $f: $!\n";
731 next if /^\s*\#/ || /^\s*$/;
732 if (/^\[([^\]]*)\]\s*$/) {
735 elsif (/^(\w+)\s*=\s*(.*)/) {
740 while (@lines && $lines[0]=~/^\s(.+)/) {
747 if ($parameter eq "include") {
748 print "mr: including output of \"$value\"\n" if $verbose;
749 unshift @lines, `$value`;
753 if (! defined $section) {
754 die "$f line $.: parameter ($parameter) not in section\n";
756 if ($section ne 'ALIAS' &&
757 ! exists $config{$dir}{$section} &&
758 exists $config{$dir}{DEFAULT}) {
760 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
762 if ($section eq 'ALIAS') {
763 $alias{$parameter}=$value;
765 elsif ($parameter eq 'lib') {
766 $config{$dir}{$section}{lib}.=$value."\n";
769 $config{$dir}{$section}{$parameter}=$value;
770 if ($parameter =~ /.*_(.*)/) {
774 $knownactions{$parameter}=1;
776 if ($parameter eq 'chain' &&
777 length $dir && $section ne "DEFAULT" &&
778 -e $dir.$section."/.mrconfig") {
779 my $ret=system($value);
781 if (($? & 127) == 2) {
782 print STDERR "mr: chain test interrupted\n";
786 print STDERR "mr: chain test received signal ".($? & 127)."\n";
790 push @toload, $dir.$section."/.mrconfig";
796 die "$f line $line: parse error\n";
805 sub modifyconfig { #{{{
807 # the section to modify or add
808 my $targetsection=shift;
809 # fields to change in the section
810 # To remove a field, set its value to "".
817 open(my $in, "<", $f) || die "mr: open $f: $!\n";
822 my $formatfield=sub {
824 my @value=split(/\n/, shift);
826 return "$field = ".shift(@value)."\n".
827 join("", map { "\t$_\n" } @value);
831 while ($out[$#out] =~ /^\s*$/) {
832 unshift @blanks, pop @out;
834 foreach my $field (sort keys %changefields) {
835 if (length $changefields{$field}) {
836 push @out, "$field = $changefields{$field}\n";
837 delete $changefields{$field};
847 if (/^\s*\#/ || /^\s*$/) {
850 elsif (/^\[([^\]]*)\]\s*$/) {
851 if (defined $section &&
852 $section eq $targetsection) {
860 elsif (/^(\w+)\s*=\s(.*)/) {
865 while (@lines && $lines[0]=~/^\s(.+)/) {
871 if ($section eq $targetsection) {
872 if (exists $changefields{$parameter}) {
873 if (length $changefields{$parameter}) {
874 $value=$changefields{$parameter};
876 delete $changefields{$parameter};
880 push @out, $formatfield->($parameter, $value);
884 if (defined $section &&
885 $section eq $targetsection) {
888 elsif (%changefields) {
889 push @out, "\n[$targetsection]\n";
890 foreach my $field (sort keys %changefields) {
891 if (length $changefields{$field}) {
892 push @out, $formatfield->($field, $changefields{$field});
897 open(my $out, ">", $f) || die "mr: write $f: $!\n";
905 # actions that do not operate on all repos
906 if ($action eq 'help') {
909 elsif ($action eq 'config') {
912 elsif ($action eq 'register') {
917 mrs($action, selectrepos());
920 foreach my $repo (selectrepos()) {
921 record($repo, action($action, @$repo));
927 exec($config{''}{DEFAULT}{help}) || die "exec: $!";
932 die "mr config: not enough parameters\n";
935 if ($section=~/^\//) {
936 # try to convert to a path relative to the config file
937 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
939 $dir.="/" unless $dir=~/\/$/;
940 if ($section=~/^\Q$dir\E(.*)/) {
946 if (/^([^=]+)=(.*)$/) {
947 $changefields{$1}=$2;
951 foreach my $topdir (sort keys %config) {
952 if (exists $config{$topdir}{$section} &&
953 exists $config{$topdir}{$section}{$_}) {
954 print $config{$topdir}{$section}{$_}."\n";
956 last if $section eq 'DEFAULT';
960 die "mr config: $section $_ not set\n";
964 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
969 if (! $config_overridden) {
970 # Find the closest known mrconfig file to the current
972 $directory.="/" unless $directory=~/\/$/;
974 foreach my $topdir (reverse sort keys %config) {
975 next unless length $topdir;
976 if ($directory=~/^\Q$topdir\E/) {
977 $ENV{MR_CONFIG}=$configfiles{$topdir};
983 if (! $foundconfig) {
984 $directory=""; # no config file, use builtin
988 my $subdir=shift @ARGV;
989 if (! chdir($subdir)) {
990 print STDERR "mr register: failed to chdir to $subdir: $!\n";
994 $ENV{MR_REPO}=getcwd();
995 my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT', 0);
996 if (! defined $command) {
997 die "mr register: unknown repository type\n";
1000 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
1001 $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
1002 "my_action(){ $command\n }; my_action ".
1003 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
1004 print "mr register: running >>$command<<\n" if $verbose;
1005 exec($command) || die "exec: $!";
1008 # alias expansion and command stemming
1009 sub expandaction { #{{{
1011 if (exists $alias{$action}) {
1012 $action=$alias{$action};
1014 if (! exists $knownactions{$action}) {
1015 my @matches = grep { /^\Q$action\E/ }
1016 keys %knownactions, keys %alias;
1017 if (@matches == 1) {
1018 $action=$matches[0];
1020 elsif (@matches == 0) {
1021 die "mr: unknown action \"$action\" (known actions: ".
1022 join(", ", sort keys %knownactions).")\n";
1025 die "mr: ambiguous action \"$action\" (matches: ".
1026 join(", ", @matches).")\n";
1033 Getopt::Long::Configure("bundling", "no_permute");
1034 my $result=GetOptions(
1035 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1036 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1037 "v|verbose" => \$verbose,
1038 "s|stats" => \$stats,
1039 "n|no-recurse" => \$no_recurse,
1040 "j|jobs=i" => \$jobs,
1042 if (! $result || @ARGV < 1) {
1043 die("Usage: mr [-d directory] action [params ...]\n".
1044 "(Use mr help for man page.)\n");
1050 print STDERR "mr: interrupted\n";
1054 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
1056 # This can happen if it's run in a directory that was removed
1057 # or other strangeness.
1058 if (! defined $directory) {
1059 die("mr: failed to determine working directory\n");
1061 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
1062 # the config file might be a symlink to elsewhere, and the directory it's
1063 # in is significant.
1064 if ($ENV{MR_CONFIG} !~ /^\//) {
1065 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
1067 # Try to set MR_PATH to the path to the program.
1069 use FindBin qw($Bin $Script);
1070 $ENV{MR_PATH}=$Bin."/".$Script;
1078 loadconfig($ENV{MR_CONFIG});
1079 #use Data::Dumper; print Dumper(\%config);
1081 my $action=expandaction(shift @ARGV);
1088 elsif (! @ok && @skipped) {
1096 # Finally, some useful actions that mr knows about by default.
1097 # These can be overridden in ~/.mrconfig.
1113 echo "mr (warning): $@" >&2
1119 if [ -z "$1" ] || [ -z "$2" ]; then
1120 error "mr: usage: hours_since action num"
1122 for dir in .git .svn .bzr CVS .hg _darcs; do
1123 if [ -e "$MR_REPO/$dir" ]; then
1124 flagfile="$MR_REPO/$dir/.mr_last$1"
1128 if [ -z "$flagfile" ]; then
1129 error "cannot determine flag filename"
1131 delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
1132 if [ "$delta" -lt "$2" ]; then
1140 svn_test = test -d "$MR_REPO"/.svn
1141 git_test = test -d "$MR_REPO"/.git
1142 bzr_test = test -d "$MR_REPO"/.bzr
1143 cvs_test = test -d "$MR_REPO"/CVS
1144 hg_test = test -d "$MR_REPO"/.hg
1145 darcs_test = test -d "$MR_REPO"/_darcs
1147 test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1148 test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1149 test "$(GIT_CONFIG="$MR_REPO"/config git config --get core.bare)" = true
1151 svn_update = svn update "$@"
1152 git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
1153 bzr_update = bzr merge "$@"
1154 cvs_update = cvs update "$@"
1155 hg_update = hg pull "$@" && hg update "$@"
1156 darcs_update = darcs pull -a "$@"
1158 svn_status = svn status "$@"
1159 git_status = git status "$@" || true
1160 bzr_status = bzr status "$@"
1161 cvs_status = cvs status "$@"
1162 hg_status = hg status "$@"
1163 darcs_status = darcs whatsnew -ls "$@"
1165 svn_commit = svn commit "$@"
1166 git_commit = git commit -a "$@" && git push --all
1167 bzr_commit = bzr commit "$@" && bzr push
1168 cvs_commit = cvs commit "$@"
1169 hg_commit = hg commit -m "$@" && hg push
1170 darcs_commit = darcs commit -a -m "$@" && darcs push -a
1172 svn_diff = svn diff "$@"
1173 git_diff = git diff "$@"
1174 bzr_diff = bzr diff "$@"
1175 cvs_diff = cvs diff "$@"
1176 hg_diff = hg diff "$@"
1177 darcs_diff = darcs diff "$@"
1179 svn_log = svn log "$@"
1180 git_log = git log "$@"
1181 bzr_log = bzr log "$@"
1182 cvs_log = cvs log "$@"
1183 hg_log = hg log "$@"
1184 darcs_log = darcs changes "$@"
1185 git_bare_log = git log "$@"
1188 url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
1189 if [ -z "$url" ]; then
1190 error "cannot determine svn url"
1192 echo "Registering svn url: $url in $MR_CONFIG"
1193 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
1195 url="$(LANG=C git config --get remote.origin.url)" || true
1196 if [ -z "$url" ]; then
1197 error "cannot determine git url"
1199 echo "Registering git url: $url in $MR_CONFIG"
1200 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
1202 url=$(cat .bzr/branch/parent)
1203 if [ -z "$url" ]; then
1204 error "cannot determine bzr url"
1206 echo "Registering bzr url: $url in $MR_CONFIG"
1207 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone '$url' '$MR_REPO'"
1209 repo=$(cat CVS/Repository)
1210 root=$(cat CVS/Root)
1211 if [ -z "$root" ]; then
1212 error "cannot determine cvs root"
1214 echo "Registering cvs repository $repo at root $root"
1215 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
1217 url=$(hg showconfig paths.default)
1218 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1219 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
1221 url=$(cat _darcs/prefs/defaultrepo)
1222 echo "Registering darcs repository $url in $MR_CONFIG"
1223 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url'p '$MR_REPO'"
1225 url="$(LANG=C GIT_CONFIG=config git config --get remote.origin.url)" || true
1226 if [ -z "$url" ]; then
1227 error "cannot determine git url"
1229 echo "Registering git url: $url in $MR_CONFIG"
1230 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
1233 if [ ! -e "$MR_PATH" ]; then
1234 error "cannot find program path"
1236 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
1240 ed = echo "A horse is a horse, of course, of course.."
1241 T = echo "I pity the fool."
1242 right = echo "Not found."
1245 # vim:sw=8:sts=0:ts=8:noet